<template>
<div class="wrapper wrapper-content animated fadeIn">
  <div class="row">
    <div class="col-lg-12">
      <div class="ibox float-e-margins">
        <div class="ibox-title">
            <h5>List Of Utility</h5>
            <div class="ibox-tools">
                <a class="btn btn-primary btn-xs" @click="modal_show()">
                    Add Utility
                </a>
                <a @click="load_utility()">
                    <i class="fa fa-refresh"></i>
                </a>
          </div>
        </div>
        <!-- /.ibox-titel -->
        
        <div class="ibox-content">
            <!-- Search and filter form -->
            <div class="row">
                <div class="col-lg-12">
                    <div class="pull-left form-inline">
                        <label>Show 
                            <input type="number" v-model="show_row" class="form-control input-sm" 
                                    style="width:60px;" min="1" max="1000">
                        </label>


                        <label>&nbsp;&nbsp;Limit
                            <input type="number" v-model="limit" class="form-control input-sm" 
                                    style="width:70px;" min="1" max="1000">
                        </label>
                    </div>

                    <div class="pull-right form-inline">
                        <label>Search:
                            <input v-model="search_key" class="form-control input-sm">
                        </label>&nbsp;
                    </div>
                </div>
            </div>
            <!-- /.row -->
          
            <div class="row" v-if="utilities.total">
                <div class="col-lg-12">
                    <div>
                        <div>
                            <p class="pull-left" style="margin-top: 7px;">
                                Showing  {{ utilities.from }} to  {{ utilities.to }}  of  {{ utilities.total }} entries.
                            </p>
                        </div>
                        <div class="table_pagination">
                            <div class="btn-group pull-right pagination pagination-sm no-margin" style="margin:-0px;">
                        
                                <a class="btn btn-white btn-sm" 
                                    v-bind:class="{ disabled : !utilities.prev_page_url }" 
                                    @click=" gen_uri( utilities.prev_page_url )"
                                >
                                    <span>Prev</span>
                                </a>  
                                <a class="btn btn-white btn-sm" 
                                    v-bind:class="{ disabled : !utilities.first_page_url }" 
                                    @click=" gen_uri( utilities.first_page_url )">
                                    <span>First</span>
                                </a>
                                <a class="btn btn-white btn-sm disabled"><span>...</span></a>
                                <a class="btn btn-white btn-sm" 
                                    v-bind:class="{ disabled : !utilities.last_page_url }" 
                                    @click=" gen_uri(utilities.last_page_url)">
                                <span>Last</span>
                                </a>
                                <a class="btn btn-white btn-sm" 
                                    v-bind:class="{ disabled : !utilities.next_page_url }" 
                                    @click=" gen_uri( utilities.next_page_url )"
                                >
                                <span>Next</span>
                                </a>
                            </div>
                        </div>        
                    </div>
                </div>
            </div>
            <!-- /.row -->

            <!-- Table -->
            <div class="table-responsive">
                <table class="table table-stripped">
                    <thead>
                        <tr>
                            <th class="text-center">#</th>
                            <th>Code</th>
                            <th>Description</th>
                            <th>&nbsp;</th>
                        </tr>
                    </thead>
                    <tbody v-if="loading">
                        <tr>
                            <td colspan="5">
                                <spinner></spinner>
                            </td>
                        </tr>
                    </tbody>
                    <tbody  v-else-if="utilities.data.length">
                        <utility-table v-for="(utility, row) in utilities.data" 
                                    :key="utility.id" 
                                    :utility="utility" 
                                    :row="row"
                                    v-on:edit="modal_show"
                                    v-on:delete="utility_delete"
                        >
                        </utility-table>
                    </tbody>
                    <tbody v-else>
                        <tr>
                            <td colspan="7" class="text-center">
                                No Result!
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
            <!-- /.table-responsive -->
        </div>
        <!-- /.ibox-content -->
      </div>
      <!-- /.ibox float-e-margins -->
    </div>
    <!-- /.col-lg-12 -->
  </div>
  <!-- /.row -->

  <utility-modal v-on:save="utility_save" v-bind:modal="modal">
  </utility-modal>
</div>  
<!-- /.wrapper wrapper-content animated fadeInRight -->
</template>

<script>
import axios from 'axios'
import Table from './Table.vue'
import Modal from './Modal.vue'
import Spinner from '../../other/Spinner.vue'
import appService from '../../../app.service.js'

export default {
    components: {
        'utility-modal': Modal,
        'utility-table': Table,
        'spinner': Spinner
    },
    data () {
        return {
            loading: false,
            search_key: '',
            show_row: 10,
            limit: 100,
            uri: '',
            utilities: [],
            modal: { 
                pause_save: false,
                errors: '',
                data: {
                    code: '',
                    description: '',
                    id: ''
                }
            },
        }
    },
    methods: {
        load_utility () {
            this.loading = true
            let uri = this.uri
            axios.get(uri).then(response => {
                this.utilities = response.data.utilities
                this.loading = false
            }).catch(response => {
                reject(response.status)
                this.loading = false
            })
        },
        gen_uri (qry_page = '') {
            let query = {
                base: 'utility',
                page: qry_page.substr(1),
                show_row: this.show_row,
                limit: this.limit,
                search_key: this.search_key,
            }
            this.uri = appService.crud.generate_url( query ) 
            this.$router.push( this.uri )
        },
        modal_show( row_data ) {
            this.modal.errors = ''

            if(row_data) {
                this.modal.data = {
                    code: row_data.code,
                    description: row_data.description,
                    id: row_data.id,
                }
            }else{
                this.modal.data = {
                    code: '',
                    description: '',
                    id: '',
                }
            }

            $('#utility_modal').modal('show');
        },
        utility_save( data ) {
            this.modal.pause_save = true
            if(!data.id) {
                this.utility_store( data )
            }else{
                this.utility_update( data )
            }
        },
        utility_store( data ) {
            appService.crud.store( '/utility', data ).then(response => {
                if(response.errors) {
                    this.modal.errors = response.errors
                }else{
                    $('#utility_modal').modal('hide')
                    toastr.success( response.message, 'Saved!' )
                    this.load_utility()
                }
                this.modal.pause_save = false
            })
        },
        utility_update( data ){
            appService.crud.update( `/utility/${data.id}`, data ).then(response => {
                if(response.errors) {
                    this.modal.errors = response.errors
                }else{
                    $('#utility_modal').modal('hide')
                    toastr.success( response.message, 'Updated!' )
                    this.load_utility()
                }
            })
            this.modal.pause_save = false
        },
        utility_delete( id ){
            appService.crud.delete( `/utility/${id}` ).then(response => {
                if(response.errors) {
                    toastr.error( response.message, 'Error!' )
                }else{
                    toastr.error( response.message, 'Deleted!' )
                    this.load_utility()
                }
            })
        },
    },  
    watch: {
        '$route' (to, from) {
            this.load_utility()
        },
        show_row: function () {
            this.loading = true
            this.gen_uri()
        },
        limit: function () {
            this.loading = true
            this.gen_uri()
        },
        search_key: function () {
            this.loading = true
            setTimeout(() => {
                this.gen_uri()
            }, 1500)
        }
    },
    created () {
        this.gen_uri()
        this.load_utility()
    }
}
</script>